/*
 * Copyright (C) 2008 by the Widelands Development Team
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#ifndef REFERENCER_H
#define REFERENCER_H

#include <string>
#include <cstring>

/// A template for types that reference objects of type Referenced. It is
/// identifiable so that it is possible to tell what is referencing something.
template<typename Referenced> struct Referencer {
	virtual ~Referencer() {}
	virtual std::string identifier() const = 0;
	void   reference(Referenced & item) {item.  reference(*this);}
	void unreference(Referenced & item) {item.unreference(*this);}
};

#endif
